/*
 *  imu.h
 *  
 *
 *  Created by Dale Heatherington on 12/23/13.
 *  
 *
 */

#ifndef imu_h
#define imu_h

#include <inttypes.h>

class Imu
{
	
public:
	Imu();
	void begin();
	void write(int, int, uint8_t);
	void read(int, int, int*, int, bool );

};

class Gyro : public Imu
{
public:
	Gyro();
	void begin();	
	void write(int,int,uint8_t);
	void read(void);
	void zero(void);
	void timer(int);
	int  timer(void);
	void tick(void);
	int x(void);
	int y(void);
	int z(void);
private:
	static int adr;
	static int values[];
	static int offsets[];
	static int counter;
	
	
	
	
};

class Accel : public Imu
{
public:
	Accel();
	void begin();
	void write(int,int,uint8_t);
	void read(void);
	void zero(void);
	void timer(int);
	int  timer(void);
	void tick(void);
	int x(void);
	int y(void);
	int z(void);
private:
	static int adr;
	static int values[];
	static int offsets[];
	static int counter;
	
	
};




class Compass : public Imu
{
public:
	Compass();
	void begin();
	void write(int,uint8_t);
	void read(void);
	void zero(void);
	//void timer(int);
	//int  timer(void);
	//void tick(void);
	int x(void);
	int y(void);
	int z(void);
private:
	static int adr;
	static int values[];
	static int offsets[];
	static int counter;
};






extern Imu imu;
extern Gyro gyro;
extern Accel accel;
extern Compass compass;


#endif

